/*
 * MyDocument.h
 * Ring Tones
 *
 * Created by Graham Booker on Fri Jun 13 2003.
 * Copyright (c) 2003 Graham Booker.
 * All rights reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining
 *  a copy of this software and associated documentation files (the "Software"),
 *  to deal in the Software without restriction, including without limitation
 *  the rights to use, copy, modify, merge, publish, distribute, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, provided that the above copyright notice(s) and this
 *  permission notice appear in all copies of the Software and that both the
 *  above copyright notice(s) and this permission notice appear in supporting
 *  documentation.
 *
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS.
 *  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR HOLDERS INCLUDED IN THIS NOTICE BE
 *  LIABLE FOR ANY CLAIM, OR ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR
 *  ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 *  IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 *  OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 *
 *  Except as contained in this notice, the name of a copyright holder shall not
 *  be used in advertising or otherwise to promote the sale, use or other dealings
 *  in this Software without prior written authorization of the copyright holder. 
 */

#import <Cocoa/Cocoa.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

typedef struct pdbheader{
    char name[32];
    short setto20;
    short unkonwn;
    long  unknown1;
    long  unknown2;
    long  unknown3;
    long  unknown4;
    long  unknown5;
    long  unknown6;
    char  ring[4];
    char  MP3P[4];
    long  unknown7;
    long  unknown8;
    short recordcount;
} __attribute__((packed)) pdbheader_t;

#define RECORDSIZE 0x2000

typedef struct recordheader{
    int recordoffset;
    int unknown;
}recordheader_t;

typedef struct id3tag{
    char name[3];
    char trackname[30];
    char artistname[30];
    char albumname[30];
    long year;
    char comment[30];
    char genre;
} __attribute__((packed)) id3tag_t;

typedef struct mpegheader{
    unsigned short sync :11;
    unsigned short version :2;
    unsigned short layer :2;
    unsigned short protection :1;
    unsigned short bitrate :4;
    unsigned short samplerate :2;
    unsigned short padding :1;
    unsigned short privatebit :1;
    unsigned short channel :2;
    unsigned short mode :2;
    unsigned short copyright :1;
    unsigned short original :1;
    unsigned short emphasis :2;
} __attribute__((packed)) mpegheader_t;

@interface MyDocument : NSDocument
{
    id	inputField;
    id	outputField;
    id	ringnameField;
    id	statusField;
    id	changeInputButton;
    id	changeOutputButton;
    id	runButton;
    id	theWindow;
    id	typeButtons;
    id	limitField;
    id	skipField;
    id	durationField;
    id	limitButtons;
}

- (IBAction)changeInput:(id)sender;
- (IBAction)changeOutput:(id)sender;
- (IBAction)runConvert:(id)sender;
- (IBAction)checkstatus:(id)sender;
- (IBAction)changeToSize:(id)sender;
- (IBAction)changeToTime:(id)sender;
@end